#include <iostream>
using namespace std;

const int MAXD = 20;

char scan1[MAXD][MAXD], scan2[MAXD][MAXD];

bool check(int r, int c1, int c2, int offset)
{
	for(int i=0; i<r; i++) {
		for(int j=0; j<offset; j++)			// scan 1 only
			if (scan1[i][j] == '0')
				return false;
		for(int j=offset; j<c1; j++) 		// scan1 and scan 2
			if (scan1[i][j] == scan2[i][j-offset])
				return false;
		for(int j=c1; j<c2+offset; j++)			// scan 1 only
			if (scan2[i][j-offset] == '0')
				return false;
	}
	return true;
}

int main()
{
	int r, c1, c2;

	cin >> r >> c1 >> c2;
if (!cin)
	return 99;
	if (r < 0 || r > MAXD)
//		cout << "ERROR: r out of range" << endl;
return 10;
	if (c1 < 0 || c1 > MAXD)
//		cout << "ERROR: c1 out of range" << endl;
return 11;
	if (c2 < 0 || c2 > MAXD)
//		cout << "ERROR: c2 out of range" << endl;
return 2;
	string s;
	getline(cin, s);
	for(int i=0; i<r; i++) {
		getline(cin,s);
		if (s.length() != c1)
//			cout << "ERROR: line " << i << " in scan 1 has incorrect length" << endl;
return 0;
		for(int j=0; j<c1; j++) {
			if (s[j] != '1' && s[j] != '0')
//				cout << "ERROR: character in line " << i << " in scan 1 incorrect" << endl;
return 1;
		}
		if (s[0] != '1')
//			cout << "ERROR: line " << i << " in scan 1 missing initial 1" << endl;
return 2;
	}
	for(int i=0; i<r; i++) {
		getline(cin,s);
		if (s.length() != c2)
//			cout << "ERROR: line " << i << " in scan 2 has incorrect length" << endl;
return 3;
		for(int j=0; j<c2; j++) {
			if (s[j] != '1' && s[j] != '0')
//				cout << "ERROR: character in line " << i << " in scan 2 incorrect" << endl;
return 4;
		}
		if (s[c2-1] != '1')
//			cout << "ERROR: line " << i << " in scan 2 missing trailing 1" << endl;
return 5;
	}

return 42;
}

